Network measurement intent - one of IBN use cases
Danyang Chen
China Mobile
Beijing
100053
China
chendanyang@chinamobile.com
Hongwei Yang
China Mobile
Beijing
100053
China
yanghongwei@chinamobile.com
Kehan Yao
China Mobile
Beijing
100053
China
yaokehan@chinamobile.com
Giuseppe Fioccola
Huawei
Riesstrasse, 25
Munich
80992
Germany
giuseppe.fioccola@huawei.com
Qin Wu
Huawei
101 Software Avenue, Yuhua District
Nanjing
210012
China
bill.wu@huawei.com
06 July 2022
Networking
Internet Research Task Force
Network measurement intent; intent
As an important technical means to detect network state, network measurement has attracted more and more attention in the development of network. However, the current network measurement technology has the problem that the measurement method and the measurement purpose cannot match well. To solve this problem, this memo introduces network measurement intent, presents a process of scheduling the network resource and measurement task to meet the user or network operator’s needs. And it can be seen as a specific use case of intent based network.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in RFC 2119.

Introduction
With the rapid growth of the present network, the scale of the network increases, while users' service requirements for the network are getting strict and diversified,e.g., both loss requirements and throughput needs to be met simultaneously. At the same time, network resources growth is hard to meet user’s service requirments. In order to make good of network resources and improve utilization of the bandwidth, it becomes necessary to understand the current running state of the network, and network measurement, as a technical means to detect the network resource change, has been paid of more attention. The continuous development of network measurement technology has also increases higher precision of network awareness. However, both the traditional network measurement technology (e.g.,loss measurement and delay measurement defined in (RFC 2679 RFC 2680) and the network telemetry technology RFC 8639 RFC 8641[I-D.ietf-netconf-adaptive-subscription], which has emerged with the development of software-defined network in recent years, need to consume more network resources when detecting the network state changes and feeding back the detection results. Therefore, to some extent, the choice of network measurement methods, in addition to different accuracy of measurement results, will also cause different level of network load to the network.
In order to balance the accuracy of network measurement results with the network load, it is very important to choose the appropriate network measurement method according to the different requirements of network measurement. As a result, accurate on-demand network measurement technology is becoming more and more important. At the same time, the development of Intent based Network (IBN) enables the network to be configured according to users' or network administrators' intent. Therefore, we can integrate the network measurement with IBN, i.e., the users' or network administrators' perceived demand for network state is regarded as network measurement intent.
Our proposed approach is to use the network measurement intent to achieve network performance acquisition based on user/network administrator intent- , verify whether network measurement results meet the measurement intent, and further improve the accuracy of the configuration in IBN.

Definitions and Acronyms
CLI: Command-line Interface.
IBN: Intent based Network.
Policy: A set of rules that governs the choices in behavior of a system.
NMI: Network Measurement Intent, refers to based on user/network operator's demand for network status, and automatically collect network status information on demand.
SLA: Service Level Agreement.

Relationship to Existing Documents
As the rise of IBN, different groups have different definitions of The intent. For example, ONF [ONOS] defines intent is represented as a list of CLI modes that allows users to pass low-level details on the network; and there are two active RG drafts in the NMRG right now, Intent-Based Networking - Concepts and Definitions, [I-D.irtf-nmrg-ibn-concepts-definitions] solves the problem that "What is an intent?" and[I-D.irtf-nmrg-ibn-intent-classification]solves the problem "Given a specific intent, how to parse/disassemble it from different angles?".
Naturally, the question that needs to be solved after concept definition should be "How to realize an specific intent?".[I-D.irtf-nmrg-ibn-intent-classification]can be considered as the first step of realization of a given intent, however, it is not enough. Some other issues should be clarified, like" whether the input intent is valid or not?" , "What would the IBN system do when the result is not acceptable?", "If the result is not acceptable, does human/operator interference required?"... We should take a specific IBN use case for illustration of the realization procedure, so we will take the network measurement intent as an example.
Referring to the taxonomy of intent proposed in [I-D.irtf-nmrg-ibn-intent-classification], the network measurement intent can be classified into different categories.
Solution: the intent could cover carrier and data center.
Intent user type: customer.
Intent type: customer service intent.
Intent scope: Application, QoS.
Network scope: Radio Access, Transport, Edge, Core.
Abstraction: Non-technical.
Lifecycle Requirements: transient.
In order to integrate the NMI with the IBN, in this document we define the components of the NMI interactive process as follows:
- NMI Recognition and Acquisition
- NMI Translation
- NMI Policy
- NMI Orchestration and pre-Verification
- Data Collection and Analytics
- NMI Compliance Assessment

Overview
As mentioned above, NMI refers to the on-demand measurement of the network state based on the user/network operators' perceived intent of the network state.The user/network operators' perceived intent is usually in the form of service level objective or service level expectation. We will take the measurement of the performance of the network overwhelming with the network traffic as a simple example and present the detailed interactive process for those components defined in section 3.
- NMI Recognition and Acquisition.
  - In this function, NMI will be recognized by "ingesting" users' or network operators' measurement intent. They have the ability to identify the NMI of a certain network performance that users want to measure, such as delay, jitter, etc., and at the same time allow users to express the NMI of network performance in a variety of interactive ways to ensure the accuracy of the identification of the NMI. To achieve this functionality, such an interaction requires the use of the intent-northbound interface defined in the IBN,e.g., service interface model in [RFC8299][RFC8466] or intent interface defined in [TMF1253A].
- NMI Translation.
  - In this function, NMI needs to be translated into corresponding measurement policy, which includes but is not limited to network performance parameters to be measured (such as delay, jitter, and packet loss), time period to be measured, and measurement unit. For a simple example, in the measurement of busy network performances, due to dynamic changes of network characteristics, such as daily network bandwidth utilization rate, the period of network busy time is not fixed. As a result, NMI Policy generated by NMI Translation can determine the threshold when the network state is busy or the network is congested on the same day based on the historical data learned by AI.
- NMI Policy
  - In this function, NMI policy needs to be translated into actions and instructioninvoked against the specified network element. Therefore, NMI policy generated by NMI Translation must be executable, that is, corresponding underlying network devices must be able to support policy execution. If the generated policy cannot be executed by the underlying device, the policy needs to be adjusted. And if the measurement results cannot meet the service requirements set by the users and network operators, the policy also needs to be adjusted.
- NMI Orchestration and pre-Verification.
  - In this function, according to the previous NMI Translation and NMI Policy step, NMI Orchestration and pre-Verification determines the measurement scheme according to the measurement policy generated by NMI Policy, and pre-verifies whether the measurement scheme is feasible.
  - Take busy time network measurement as an example, besides choosing of measurement schemes and assigning measurement tasks [RFC8639][RFC8641][I-D.ietf-netconf-adaptive-subscription][RFC8194][I-D.ietf-netmod-eca-policy], it also needs to determine whether the network is busy according to the current network state. In addition, this function performs automatic network deployment,e.g.,using model driven network management approach defined in [RFC8969].
- Data Collection and Analytics.
  - In NMI, data collection and analysis should be based on the selected measurement scheme and parameters set to be measured that determined in previous steps, automatically realize the collection on demand, and generate corresponding data analysis results.
- NMI Compliance Assessment.
  - At the end, this function verifies whether the results meets the service requirement and whether the NMI is satisfied. If either of the two conditions is not satisfied, the NMI should be modified and re-enter the NMI Policy.
And he measurement flow diagram is shown as the following figure:
            +                  ^
  NMI input|                  |
 +---------v-------+          |
 | NMI Recognition |          |Measurement
 |and Acquisition  |          |Results
 +--------+--------+          |Feedback
          |                   |
 +--------v--------+          |
 | NMI Translation |          |
 +--------+--------+          |
          |               +---+----- -----+
 +--------v--------+      |NMI Compliance |
 |   NMI Policy    <------+Assessment     |
 +--------+--------+      +--^------------+
          |                  |
+---------v-----------+   +--+--------------+
| NMI Orchestration   |   | Data Collection |
| and pre-Verification|   | and Analytics   |
+---------+-----------+   +--^--------------+
          |                  |
      +---v------------------+---+
      |   Network Infrastructure |
      +--------------------------+

Concrete Examples
In this section, we will take SLA measurement intent as an example to illustrate each step of the process.
With the development of measurement technology in recent years, network measurement methods can be divided into active measurement, passive measurement and a hybrid measurement [RFC7799]. No matter which measurement technology is used, the network resource consumption will be influenced by the network condition and change over the time.e.g.,, if the transmission frequency of active measurement message is too fast, it will occupy too much bandwidth resources and affect the normal operation of actual business. While if the transmission frequency is too slow, some instantaneous network anomalies will be missed and the network status cannot be accurately reflected. Passive measurement requires real- time collection of actual business data. If the sampling rate is too high, a large amount of data will be accumulated in a short time [I-D.ietf-netconf-adaptive-subscription].The analysis system for real-time analysis of these data needs strong processing capacity; if the sampling rate is too low, some network anomalies will also be omitted.
How to balance and accurately measure the network state, especially the abnormal network affecting the service, while occupying as little network bandwidth as possible, and the processing capacity of the data analysis system is not high, this is the function that the NMI scheme based on IBN should realize.
In this section, we will consider two examples to illustrate each step of the process.

Time Accuracy Measurement
Taking network SLA performance metric -- delay measurement as an example, the simple schematic diagram is as follows, different thresholds, warning value and alert value should be set for network delay in advance. When the delay value is below warning, the network is normal and the business is normal. When the delay is between warning value and alert value, the network fluctuation is abnormal, but the business is normal. When the delay exceeds the alert value, both the network and business are abnormal. For delay in different thresholds, different measurement strategies should be adopted:
- When the network delay exceeds the alert value, or when the historical data predict that the delay will exceed the alert value, passive measurement requires 100% sampling of business data, and the transmission frequency of active measurement is modulated to the maximum. At the same time, the log and alarm data of the whole network equipment are collected to realize the most fine-grained measurement of the network, locate the root cause of the problem and repair the network in time.
- When the network delay exceeds warning value but is lower than alert value, passive measurement samples 60% of business data, and the transmission message frequency of the active measurement is adjusted to the median value, and the running state data of some key devices in the network is collected synchronously.
- When the network delay is less than warning value, passive measurement data is sampled at 20%, and active measurement message frequency is adjusted to the lowest, and the network equipment running state of key nodes can be collected as needed.
        ^ms
        |
        |
        |                         XX
        |                        X X            Sampling Rate 100%
        |                       XX X
  alert +--------------------------------------------------------+
        |                      X   X             Sampling Rate 60%
        |                     X    XX
        |                    X      X                XX
        |          XX        X      X                XXX
        |          XXX       X       X              X  X
        |         XX X      X        X             X   XX
        |         X   XX    X        X  XX   XX    X    XX
warning +-------------------------------------------------------+
        |         X    XX  X          XX X  XX X  XX      XX
        |     XX  X     X  X          X   XX   XX X        X
        |    XX X X     X  X          X   XX    XXX         X
        |   X   XX       XXX          X         XX          X
        |   X   XX       XX           X
        |        X       XX                      Sampling Rate 20%
        |
        +----------------------------------------------------------->

Based on the above SLA time delay index measurement, different thresholds adopt different measurement strategies, the concrete steps of SLA measurement intent are as follows:
- In NMI Recognition and Acquisition, SLA measurement intent is recognized, and business requirements and performance metrics are identified by interacting with users. Then the NMI Recognition and Acquisition module inputs the SLA measurement intent into the NMI Translation module.
- The NMI Translation module consolidates the SLA measurement intent with the measurement policy in NMI Policy, and outputs the executable measurement policy, such as the message transmission frequency of active measurement, the sampling rate of passive measurement, the collection range of equipment running state, etc.
- The NMI Orchestration and pre-Verification module uses the measurement policy as input and for orchestration layer which is responsible for translating it into the specific configuration and execution time of each device in the tested network. The NMI Orchestration and pre-Verification module verifies the implementation of the policy in the equipment and pre-analyzes the measurement results.
- The Data Collection and Analysis module will collect the measurement data according to the configuration and execution time requirements of the previous step, make a simple analysis of the collected data (e.g.,verify the correctness of the measurement data), and then send the collected measurement data to the NMI Compliance Assessment module. After that, the NMI Compliance Assessment module feedbacks the measurement results (e.g., the measurement results match user intent) to the user to complete the closed loop of the measurement task.
- The NMI Compliance Assessment module evaluates whether the actual measurement results are in line with the user's intent. If they are, the results will be fed back. If they are not, the NMI Policy module will be informed to adjust the policy, and then the measurement will be restarted. According to the measurement results, the NMI Compliance Assessment module notifies the NMI Orchestration and pre-Verification module to modify the execution time of the policy in time, and at the same time updates the measured results to the delay history database to improve the accuracy of delay prediction.

Spatial Accuracy Measurement
The desired approach is to accurately measure the network state, especially when there are some issues affecting the service, but at the same time, reduce the resources to be employed to achieve the desired accuracy.
In this regard, the Clustered Alternate-Marking framework[RFC8889] adds flexibility to Performance Measurement (PM), because it can reduce the order of magnitude of the packet counters. This allows the NMI Orchestration and pre-Verification module to supervise, control, and manage PM in large networks.
[RFC8889] introduces the concept of cluster partition of a network. The monitored network can be considered as a whole or split into clusters that are the smallest subnetworks (group-to-group segments), maintaining the packet loss property for each subnetwork. The clusters can be combined in new connected subnetworks at different levels, forming new clusters, depending on the level of detail to achieve.
The clustered performance measurement intent represents the spatial accuracy, that is the size of the subnetworks to consider for the monitoring. It is possible to start without examining in depth and, in case of necessity, the "network zooming" approach can be used.
This approach called "network zooming" and can be performed in two different ways:
1. change the traffic filter and select more detailed flows;
2. activate new measurement points by defining more specified clusters.
The network-zooming approach implies that some filters, rules or flow identifiers are changed. But these changes must be done in a way that do not affect the performance. Therefore there could be a transient time to wait once the new network configuration takes effect. Anyway, if the performance issue is relevant, it is likely to last for a time much longer than the transient time.
The concrete steps of the clustered performance measurement intent are as follows:
- In NMI Recognition and Acquisition, the clustered performance measurement intent is recognized. Then the NMI Recognition and Acquisition module inputs the clustered performance measurement intent into the NMI Translation module.
- The NMI Translation module analyzes the clustered performance measurement intent and outputs the executable measurement policy, such as network partition and the spatial accuracy for the monitoring.
- The NMI Orchestration and pre-Verification module arranges and calibrates the measurement with the specific configuration to split the whole network into clusters at different levels.
- The Data Collection and Analysis module collects the measurement data from the different clusters, and then send these data to the NMI Compliance Assessment module. It verifies the performance for each cluster and send the measurement results to the user.
- The NMI Compliance Assessment module, in case a cluster is experiencing a packet loss or the delay is high, notifies the NMI Orchestration and pre-Verification module to modify the cluster partition of the network for further investigation. The network configuration can be immediately modified in order to perform a new partition of the network but only for the cluster with bad performance. In this way, the problem can be localized with successive approximation up to a flow detailed analysis. This is the so-called "closed loop" performance management.

Classification of NMI
In this section, we divide the network measurement intent into static NMI and dynamic NMI according to different requirement characteristics.

Static NMI
Static NMI refers to the measurement purposes remain unchanged and is independent of the network state/external environment. Static NMI can be translated into determined network performance indicator values, such as concrete delay values, network bandwidth utilization, throughput and so on.
Because the static NMI can be translated into the measurement of the determined network performance parameters, the whole process is relatively simple and error-prone, and only needs to verify whether the measurement results meet the requirements.

Dynamic NMI
Dynamic NMI refers to the measurement purpose remains unchanged but the measurement process changes dynamically according to the network state/external environment. Dynamic NMI can also be translated into the measurement of determined network performance parameters, however, the values of network performance parameters will change with the changes of network states and external environment.
For example, the measurement of busy network performances mentioned in the previous section. Although the corresponding network parameters for judging whether the network is busy are determined, the corresponding network parameters have different values according to different network states and external environments.
Due to the dynamic nature of dynamic NMI, its processing process is more complex than static NMI. It is not only necessary to verify the accuracy of demand analysis, but also to verify whether the final measurement results meet the requirements.

Security Considerations
This document introduces the network measurement intent, and uses two concrete examples to illustrate the process of network measurement intent. On the basis of existing intent work, this document can be used as a use case for IBN.
[I-D.irtf-nmrg-ibn-concepts-definitions]provides a comprehensive discussion of security considerations in the context of IBN, which are generally applicable also to the network measurement intent discussed in this document.

IANA Considerations
This document has no requests to IANA.

Normative References

Informative References
[I-D.ietf-netconf-adaptive-subscription]
[I-D.irtf-nmrg-ibn-concepts-definitions]
[I-D.irtf-nmrg-ibn-intent-classification]
[RFC8299]
[RFC8466]
[RFC8639]
[RFC8641]
[RFC8194]
[I-D.ietf-netmod-eca-policy]
[RFC8969]
[RFC7799]
[RFC8889]